Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 85)
@@ -8,38 +8,39 @@
 public abstract class Dispatching {
 
-    public static boolean isThreadSafe() {
-        return true;
-    }
+	public static boolean isThreadSafe() {
+		return true;
+	}
 
-    public static void invokeLaterOrNow(Dispatcher dispatcher, Runnable runnable) {
-        if (dispatcher.isActive()) {
-            runnable.run();
-            return;
-        }
-        dispatcher.invokeLater(runnable);
-    }
+	public static <C> void invokeLaterOrNow(Dispatcher<C> dispatcher, RunAt<? extends C> runnable) {
+		if (dispatcher.isActive()) {
+			runnable.run();
+			return;
+		}
+		dispatcher.invokeLater(runnable);
+	}
 
-    public static void dispatchOk(Dispatcher dispatcher, final StateFunctor stateFunctor) {
-        dispatcher.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                stateFunctor.call(null);
-            }
-        });
-    }
+	//TODO RunAt StateFunctor
+	public static <C> void dispatchOk(Dispatcher<C> dispatcher, final StateFunctor stateFunctor) {
+		dispatcher.invokeLater(new RunAt<C>() {
+			@Override
+			public void run() {
+				stateFunctor.call(null);
+			}
+		});
+	}
 
-    public static boolean assertInvokeLater(Dispatcher dispatcher, Runnable runnable) {
-        dispatcher.invokeLater(runnable);
-        return true;
-    }
+	// public static boolean assertInvokeLater(Dispatcher dispatcher, RunAt runnable) {
+	// 	dispatcher.invokeLater(runnable);
+	// 	return true;
+	// }
 
-    public static void invokeDispatch(Dispatcher dispatcher, final Dispatcher finalDispatcher, final Runnable runnable) {
-        dispatcher.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                finalDispatcher.invokeLater(runnable);
-            }
-        });
-    }
+	public static <P, C> void invokeDispatch(Dispatcher<P> dispatcher, final Dispatcher<C> finalDispatcher, final RunAt<C> runnable) {
+		dispatcher.invokeLater(new RunAt<P>() {
+			@Override
+			public void run() {
+				finalDispatcher.invokeLater(runnable);
+			}
+		});
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java	(revision 85)
+++ java/main/src/main/java/com/framsticks/util/dispatching/RunAt.java	(revision 85)
@@ -0,0 +1,11 @@
+package com.framsticks.util.dispatching;
+
+public abstract class RunAt<C> implements java.lang.Runnable {
+
+	public RunAt() {
+	}
+
+	public RunAt(Dispatcher<? super C> dispatcher) {
+		dispatcher.invokeLater(this);
+	}
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Task.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Task.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Task.java	(revision 85)
@@ -4,19 +4,19 @@
  * @author Piotr Sniegowski
  */
-public abstract class Task implements Runnable {
+public abstract class Task<C> extends RunAt<C> {
 
-    protected final long moment;
+	protected final long moment;
 
-    public Task() {
-        moment = System.currentTimeMillis();
-    }
+	public Task() {
+		moment = System.currentTimeMillis();
+	}
 
-    public Task(long moment) {
-        this.moment = moment;
-    }
+	public Task(long moment) {
+		this.moment = moment;
+	}
 
-    public final long getMoment() {
-        return moment;
-    }
+	public final long getMoment() {
+		return moment;
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 85)
@@ -5,9 +5,10 @@
 import java.util.LinkedList;
 import java.util.ListIterator;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
  * @author Piotr Sniegowski
  */
-public class Thread implements Dispatcher {
+public class Thread<C> implements Dispatcher<C> {
 
 	private static final Logger log = Logger.getLogger(Thread.class.getName());
@@ -15,8 +16,8 @@
 	protected final java.lang.Thread thread;
 
-	private final LinkedList<Task> queue = new LinkedList<Task>();
+	private final LinkedList<Task<? extends C>> queue = new LinkedList<>();
 
 	public Thread() {
-		thread = new java.lang.Thread(new Runnable() {
+		thread = new java.lang.Thread(new java.lang.Runnable() {
 			@Override
 			public void run() {
@@ -25,8 +26,9 @@
 		});
 	}
+
 	public Thread(String s) {
 		this();
 		thread.setName(s);
-		thread.start();
+		// thread.start();
 	}
 
@@ -34,4 +36,9 @@
 		this.thread = thread;
 		thread.setName(s);
+	}
+
+	public Thread<C> start() {
+		thread.start();
+		return this;
 	}
 
@@ -43,5 +50,5 @@
 	protected void routine() {
 		while (!java.lang.Thread.interrupted()) {
-			Task task;
+			Task<? extends C> task;
 			synchronized (queue) {
 				if (queue.isEmpty()) {
@@ -74,9 +81,9 @@
 	}
 
-	protected void enqueueTask(Task task) {
+	protected void enqueueTask(Task<? extends C> task) {
 		synchronized (queue) {
-			ListIterator<Task> i = queue.listIterator();
+			ListIterator<Task<? extends C>> i = queue.listIterator();
 			while (i.hasNext()) {
-				Task t = i.next();
+				Task<? extends C> t = i.next();
 				if (t.getMoment() > task.getMoment()) {
 					i.previous();
@@ -104,7 +111,7 @@
 
 	@Override
-	public void invokeLater(final Runnable runnable) {
+	public void invokeLater(final RunAt<? extends C> runnable) {
 		if (!(runnable instanceof Task)) {
-			enqueueTask(new Task() {
+			enqueueTask(new Task<C>() {
 				@Override
 				public void run() {
@@ -114,5 +121,5 @@
 			return;
 		}
-		enqueueTask((Task)runnable);
+		enqueueTask((Task<? extends C>) runnable);
 	}
 
@@ -125,11 +132,11 @@
 	}
 
-	public void start() {
-		thread.start();
-	}
-
 	public void setName(String name) {
 		thread.setName(name);
 
 	}
+
+	public static boolean interrupted() {
+		return java.lang.Thread.interrupted();
+	}
 }
Index: java/main/src/main/java/com/framsticks/util/io/Encoding.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/io/Encoding.java	(revision 85)
+++ java/main/src/main/java/com/framsticks/util/io/Encoding.java	(revision 85)
@@ -0,0 +1,23 @@
+package com.framsticks.util.io;
+
+import java.nio.charset.Charset;
+
+public final class Encoding {
+
+	protected static final Charset defaultCharset = Charset.forName("UTF-8");
+
+	protected static final Charset framsticksCharset = Charset.forName("ISO-8859-1");
+
+
+	protected Encoding() {
+	}
+
+	public static Charset getFramsticksCharset() {
+		return framsticksCharset;
+	}
+
+	public static Charset getDefaultCharset() {
+		return defaultCharset;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/lang/ScopeEnd.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/ScopeEnd.java	(revision 85)
+++ java/main/src/main/java/com/framsticks/util/lang/ScopeEnd.java	(revision 85)
@@ -0,0 +1,6 @@
+package com.framsticks.util.lang;
+
+public interface ScopeEnd extends AutoCloseable {
+	@Override
+	public void close();
+}
Index: java/main/src/main/java/com/framsticks/visualization/Viewer.java
===================================================================
--- java/main/src/main/java/com/framsticks/visualization/Viewer.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/visualization/Viewer.java	(revision 85)
@@ -1,4 +1,5 @@
 package com.framsticks.visualization;
 
+import com.framsticks.util.io.Encoding;
 import com.sun.j3d.loaders.IncorrectFormatException;
 import com.sun.j3d.loaders.ParsingErrorException;
@@ -18,145 +19,139 @@
 import java.io.*;
 
-// import org.apache.log4j.Logger;
+import org.apache.log4j.Logger;
 
 public class Viewer {
 
-    // private static Logger log = Logger.getLogger(Viewer.class);
+	private static Logger log = Logger.getLogger(Viewer.class);
 
-    Canvas3D canvas3d;
-    SimpleUniverse universe;
+	Canvas3D canvas3d;
+	SimpleUniverse universe;
 
-    public Viewer() {
-        super();
+	public Viewer() {
+		super();
 
-        init();
-    }
+		init();
+	}
 
 	public BranchGroup createSceneGraph() {
-        // Create the root of the branch graph
-        BranchGroup objRoot = new BranchGroup();
+		// Create the root of the branch graph
+		BranchGroup objRoot = new BranchGroup();
 
-        // Create a Transform group to scale all objects so they
-        // appear in the scene.
-        TransformGroup objScale = new TransformGroup();
-        Transform3D t3d = new Transform3D();
-        t3d.setScale(0.7);
-        objScale.setTransform(t3d);
-        objRoot.addChild(objScale);
+		// Create a Transform group to scale all objects so they
+		// appear in the scene.
+		TransformGroup objScale = new TransformGroup();
+		Transform3D t3d = new Transform3D();
+		t3d.setScale(0.7);
+		objScale.setTransform(t3d);
+		objRoot.addChild(objScale);
 
-        TransformGroup objTrans = new TransformGroup();
-        objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
-        objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
-        objScale.addChild(objTrans);
+		TransformGroup objTrans = new TransformGroup();
+		objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
+		objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
+		objScale.addChild(objTrans);
 
-        String filename = "/visualization/models/cylinder.obj";
-        int flags = ObjectFile.RESIZE;
-        flags |= ObjectFile.TRIANGULATE;
-        flags |= ObjectFile.STRIPIFY;
+		String filename = "/visualization/models/cylinder.obj";
+		int flags = ObjectFile.RESIZE;
+		flags |= ObjectFile.TRIANGULATE;
+		flags |= ObjectFile.STRIPIFY;
 		double creaseAngle = 60.0;
 		ObjectFile f = new ObjectFile(flags,
-                (float) (creaseAngle * Math.PI / 180.0));
-        Scene s = null;
-        try {
+				(float) (creaseAngle * Math.PI / 180.0));
+		Scene s = null;
+		try {
 			InputStream is = this.getClass().getResourceAsStream(filename);
-            s = f.load(new InputStreamReader(is));
-        } catch (FileNotFoundException e) {
-            System.err.println(e);
-            System.exit(1);
-        } catch (ParsingErrorException e) {
-            System.err.println(e);
-            System.exit(1);
-        } catch (IncorrectFormatException e) {
-            System.err.println(e);
-            System.exit(1);
-        }
+			s = f.load(new InputStreamReader(is, Encoding.getDefaultCharset()));
+		} catch (FileNotFoundException | ParsingErrorException | IncorrectFormatException e) {
+			log.fatal("fatal error", e);
+			return null;
+		}
 
-        objTrans.addChild(s.getSceneGroup());
+		objTrans.addChild(s.getSceneGroup());
 
-        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
+		BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
 
-        Color3f bgColor = new Color3f(0.05f, 0.05f, 0.5f);
-        Background bgNode = new Background(bgColor);
-        bgNode.setApplicationBounds(bounds);
-        objRoot.addChild(bgNode);
+		Color3f bgColor = new Color3f(0.05f, 0.05f, 0.5f);
+		Background bgNode = new Background(bgColor);
+		bgNode.setApplicationBounds(bounds);
+		objRoot.addChild(bgNode);
 
-        return objRoot;
-    }
+		return objRoot;
+	}
 
-    private void init() {
+	private void init() {
 
-	    JTextPane textPane = new JTextPane();
-        textPane.setEditable(false);
+		JTextPane textPane = new JTextPane();
+		textPane.setEditable(false);
 
-        GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
+		GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
 
-        // Create a Canvas3D using the preferred configuration
-        canvas3d = new Canvas3D(config);
+		// Create a Canvas3D using the preferred configuration
+		canvas3d = new Canvas3D(config);
 
-        // Create simple universe with view branch
-        universe = new SimpleUniverse(canvas3d);
-        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
+		// Create simple universe with view branch
+		universe = new SimpleUniverse(canvas3d);
+		BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
 
-        // add mouse behaviours to the ViewingPlatform
-        ViewingPlatform viewingPlatform = universe.getViewingPlatform();
+		// add mouse behaviours to the ViewingPlatform
+		ViewingPlatform viewingPlatform = universe.getViewingPlatform();
 
-        PlatformGeometry platformGeometry = new PlatformGeometry();
+		PlatformGeometry platformGeometry = new PlatformGeometry();
 
-        // Set up the ambient light
-        Color3f ambientColor = new Color3f(0.1f, 0.1f, 0.1f);
-        AmbientLight ambientLightNode = new AmbientLight(ambientColor);
-        ambientLightNode.setInfluencingBounds(bounds);
-        platformGeometry.addChild(ambientLightNode);
+		// Set up the ambient light
+		Color3f ambientColor = new Color3f(0.1f, 0.1f, 0.1f);
+		AmbientLight ambientLightNode = new AmbientLight(ambientColor);
+		ambientLightNode.setInfluencingBounds(bounds);
+		platformGeometry.addChild(ambientLightNode);
 
-        // Set up the directional lights
-        Color3f light1Color = new Color3f(1.0f, 1.0f, 0.9f);
-        Vector3f light1Direction = new Vector3f(1.0f, 1.0f, 1.0f);
-        Color3f light2Color = new Color3f(1.0f, 1.0f, 1.0f);
-        Vector3f light2Direction = new Vector3f(-1.0f, -1.0f, -1.0f);
+		// Set up the directional lights
+		Color3f light1Color = new Color3f(1.0f, 1.0f, 0.9f);
+		Vector3f light1Direction = new Vector3f(1.0f, 1.0f, 1.0f);
+		Color3f light2Color = new Color3f(1.0f, 1.0f, 1.0f);
+		Vector3f light2Direction = new Vector3f(-1.0f, -1.0f, -1.0f);
 
-        DirectionalLight light1 = new DirectionalLight(light1Color,
-                light1Direction);
-        light1.setInfluencingBounds(bounds);
-        platformGeometry.addChild(light1);
+		DirectionalLight light1 = new DirectionalLight(light1Color,
+				light1Direction);
+		light1.setInfluencingBounds(bounds);
+		platformGeometry.addChild(light1);
 
-        DirectionalLight light2 = new DirectionalLight(light2Color,
-                light2Direction);
-        light2.setInfluencingBounds(bounds);
-        platformGeometry.addChild(light2);
+		DirectionalLight light2 = new DirectionalLight(light2Color,
+				light2Direction);
+		light2.setInfluencingBounds(bounds);
+		platformGeometry.addChild(light2);
 
-        viewingPlatform.setPlatformGeometry(platformGeometry);
+		viewingPlatform.setPlatformGeometry(platformGeometry);
 
-        viewingPlatform.setNominalViewingTransform();
+		viewingPlatform.setNominalViewingTransform();
 
-        // Ensure at least 5 msec per frame (i.e., < 200Hz)
-        universe.getViewer().getView().setMinimumFrameCycleTime(5);
+		// Ensure at least 5 msec per frame (i.e., < 200Hz)
+		universe.getViewer().getView().setMinimumFrameCycleTime(5);
 
-        BranchGroup scene = new BranchGroup();
-        BranchGroup content = createSceneGraph();
+		BranchGroup scene = new BranchGroup();
+		BranchGroup content = createSceneGraph();
 
-        // canvas3d.addMouseListener(behaviour);
-        TransformGroup transformGroup = new TransformGroup(new Transform3D());
-        transformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
-        transformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
-        MouseRotate behaviour = new MouseRotate();
-        behaviour.setTransformGroup(transformGroup);
-        transformGroup.addChild(behaviour);
-        // behaviour.addListener(canvas3d);
-        // behaviour.initialize();
-        behaviour.setSchedulingBounds(new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0));
-        transformGroup.addChild(content);
-        // transformGroup.addChild(behaviour);
-        scene.addChild(transformGroup);
+		// canvas3d.addMouseListener(behaviour);
+		TransformGroup transformGroup = new TransformGroup(new Transform3D());
+		transformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
+		transformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
+		MouseRotate behaviour = new MouseRotate();
+		behaviour.setTransformGroup(transformGroup);
+		transformGroup.addChild(behaviour);
+		// behaviour.addListener(canvas3d);
+		// behaviour.initialize();
+		behaviour.setSchedulingBounds(new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0));
+		transformGroup.addChild(content);
+		// transformGroup.addChild(behaviour);
+		scene.addChild(transformGroup);
 
-        universe.addBranchGraph(scene);
+		universe.addBranchGraph(scene);
 		canvas3d.startRenderer();
 		Dimension d = new Dimension(500, 500);
 		canvas3d.setMinimumSize(d);
 		canvas3d.setSize(d);
-    }
+	}
 
-    public Component getViewComponent() {
-        return canvas3d;
-    }
+	public Component getViewComponent() {
+		return canvas3d;
+	}
 
 
